'**-------------------------------------------------------------------------------
'** Modul        : MODULE1.BAS
'** Aufgabe      : Hilfsroutinen fr ISDNCOPY
'**
'** (c) 1995 by Bruno Jennrich & Michael Tischer
'**-------------------------------------------------------------------------------
'
Option Explicit

'-- Deklaration externer API-Funktion --------------------------------------------

Declare Function GetTickCount& Lib "User" ()
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, lpString As Any, ByVal lplFileName As String) As Integer
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long

Global Const WM_USER = &H400                   'Konstanten fr SendMessage
Global Const LB_ERR = (-1)
Global Const LB_FINDSTRING = (WM_USER + 16)
Global Const CB_FINDSTRING = (WM_USER + 12)

'-- Deklaration der API-Funktion aus DIRSERVE.DLL ---------------------------

Declare Sub GetDir Lib "dirserve.dll" (ByVal hWnd%, ByVal startdir$, ByVal attr%)
Declare Sub AscendingDir Lib "dirserve.dll" (ByVal hWndDest%, ByVal hwndSource%)

Global Const A_NORMAL = &H0   'Konstanten fr GetDir
Global Const A_RDONLY = &H1
Global Const A_HIDDEN = &H2
Global Const A_SYSTEM = &H4
Global Const A_VOLID = &H8
Global Const A_SUBDIR = &H10
Global Const A_ARCH = &H20


Global Const LST_INNDRIVEPATH$ = "<Ungltige Laufwerks oder Pfadangabe!>"


Global OverwriteValue%        'speichert Rckgabewert des Forms frmOverwrite

Global Const OV_Cancel = 0    'bezeichnen den Inhalt von OverwriteValue
Global Const OV_YES = 1
Global Const OV_NO = 2
Global Const OV_ALL = 3

'**-------------------------------------------------------------------------------
'** Funktion     : GetCurrentDir$
'** Aufgabe      : Liest das aktuelle Verzeichnis in eine Listbox ein
'**
'** Parameter    : d = sichtbare Listbox fr Dateien und Verzeichnisse
'**                v = unsichtbare Listbox, in der die Aufbereitung erfolgt
'** Rckgabewert : Pfad des aktuellen Verzeichnisses, ist leer, wenn das aktuelle
'**                Verzeichnis nicht gelesen werden konnte
'**-------------------------------------------------------------------------------
'
Function GetCurrentDir$ (d As Control, v As Control)
    Dim pfad$
    On Error Resume Next
    Screen.MousePointer = 11                'Mauszeiger auf Sanduhr
    
    v.Clear                                 'die beiden Listboxen leeren
    d.Clear
    
    GetDir v.hWnd, "*.*", A_SUBDIR          'gesamtes Verzeicnis in die unsichtbare Listbox einlesen
    AscendingDir d.hWnd, v.hWnd             'Verzeichnisse von Dateien trennen und in die sichtbare Listbox kopieren
    
    d.ListIndex = 0                         'ersten Listboxeintrag auswhlen
    pfad$ = CurDir$                         'aktuelles Verzeichnis holen
    If Err <> 0 Then                        'Fehler?
        d.AddItem LST_INNDRIVEPATH$         'ja, Meldung in Listbox anzeigen
    End If

    If Right$(pfad$, 1) <> "\" Then         ' \ an Pfadangabe anhngen
        pfad$ = pfad$ + "\"
    End If
    GetCurrentDir$ = pfad$
    Screen.MousePointer = 0                 'Mauszeiger wieder normal

End Function

'**-------------------------------------------------------------------------------
'** Funktion     : Overwrite
'** Aufgabe      : Gibt dem Anwender die Mglichkeit zu entscheiden, ob bereits
'**                vorhandene Dateien beim Kopieren berschrieben werden sollen
'** Parameter    : srcFile$      = Name der Quelldatei
'**                dstFile$      = Name der Zieldatei
'**                LocalToRemot% = Vom CLient zum Server oder umgekehrt?
'** Rckgabewert : eine der Konstanten OV_...
'**-------------------------------------------------------------------------------
'
Function Overwrite% (srcFile$, dstFile$, LocalToRemote%)
    OverwriteValue% = OV_Cancel
    frmOverwrite.FileSrc = srcFile
    frmOverwrite.FileDst = dstFile
    If LocalToRemote Then
        frmOverwrite.DstLocalRemote = "Remote"
        frmOverwrite.SrcLocalRemote = "lokal"
    Else
        frmOverwrite.DstLocalRemote = "lokal"
        frmOverwrite.SrcLocalRemote = "Remote"
    End If

    frmOverwrite.Show 1
    Overwrite% = OverwriteValue%
End Function

