
;
;
;	PROGRAM:    ZVCKERNL.ASM - Low level assembler routines for
;		    Voice Adpcm 2 / 3 bit Converting
;
;
memS=1	    ; SMALL MODE

?PLM=0	    ; PASCAL Calling convention is DEFAULT
?WIN=0	    ; Windows calling convention
?386=0	    ; Use 386 code?

.xlist
	include cmacros.inc
.list

; The following structure should be used to access high and low
; words of a DWORD.  This means that "word ptr foo[2]" -> "foo.hi".

LONG	struc
  loword	   dw	   ?
  hiword	   dw	   ?
LONG	ends

FARPOINTER	struc
  off		   dw	   ?
  sel		   dw	   ?
FARPOINTER	ends

ZVAPIFILECONV	struc
   cbRcnt	   db	   ?		;0
   cbCompBit	   db	   ?		;1

   nRdata	   dw	   ?		;2
   nEstMax	   dw	   ?		;4
   nDelta	   dw	   ?		;6
   nBlkCnt	   dw	   ?		;8
   nData	   dw	   ?		;10
   nPack	   dw	   ?		;12

   nMaxTbl	   dw	   ?		;14
		   dw	   ?		;15
		   dw	   ?		;16
		   dw	   ?		;17
ZVAPIFILECONV	ends

ZVAPITOADPCMRESULT struc
   szAdpcmData	   db	10 dup(?)	;0 - 9
   nDataByte	   dw	?		;10
ZVAPITOADPCMRESULT ends


ifndef SEGNAME
    SEGNAME equ <TEXT>
endif


if ?386
    createSeg _%SEGNAME, CodeSeg, word, use16, CODE
else
    createSeg _%SEGNAME, CodeSeg, word, public, CODE
endif


NOT_SUPPORTED	  =  2h      ; Return code from IsDeviceRemote function.
TRUE		  =  1h      ; TRUE Definition
FALSE		  =  0h      ; False Definition.

;=============================================================================

sBegin DATA		; Put Global data here
cbSignBit		db	?
adpcmdata		db	12 dup(0)
bfPack			db	?
sEnd   DATA

;=============================================================================

sBegin CodeSeg

assumes CS,CodeSeg
assumes DS,DATA


;
;	FUNCTION:	Adaptive
;
;	LPZVAPIFILECONV lpzf
;

cProc Adaptive,<PUBLIC, NEAR>,<es, ds, si, di>
parmB cbDataBit
parmD lpzf
cBegin
		les	di,lpzf 		;
		;
		;    Filter Fourmula
		;    X = (X * 4093 + 2048)/ 4096
		;
		mov	ax,es:[di+4]		; get EstMax Value
		mov	bx,4093 		;
		imul	bx			;
		add	ax,2048 		;
		adc	dx,0			;
		;
		mov	cx,12			;
f_000:		sar	dx,1			;
		rcr	ax,1			;
		loop	f_000			;
		mov	es:[di+4],ax		;  restore nEstMax
		;
		xor	ax,ax			;  determine cbSignBit
		mov	al,es:[di+1]		;
		shl	ax,1			;
		mov	ah,al			;  save lpzf->cbCompBit << 1
		and	al,cbDataBit		;
		mov	cbSignBit,al		;
		;
		not	ah			;
		and	cbDataBit,ah		;  cbDataBit &= ~(lpzf->cbCompBit << 1)
		;
		test	word ptr es:[di+6],01h	;
		jz	f_003			;
		cmp	cbSignBit,0		;
		jnz	f_003			;
		inc	word ptr es:[di+4]	;
f_003:		;
		; Calculate the EstMax
		;
		mov	ax,es:[di+6]		; get nDelta Value
		sar	ax,1			; nTmpMax  = (lpzf->nDelta>>1)
		xor	ch,ch			;
		mov	cl,cbDataBit		;
		jcxz	e_001			;
e_000:						;
		add	ax,es:[di+6]		; nTmpMax += lpzf->nDelta
		loop	e_000			;
e_001:
		cmp	cbSignBit,0		; determine EstMax Value
		jz	e_002			;
		sub	es:[di+4],ax		;
		jmp	e_003			;
e_002:
		add	es:[di+4],ax		; save nEstMax
e_003:		;
		; Calculate the Delta
		;
		mov	ax,es:[di+6]		; lTmpDelta = lpzf->nDelta
		xor	bh,bh			;
		mov	bl,cbDataBit		;
		shl	bx,1			;
		mov	bx,es:[di+bx+14]	; (int)lpzf->nMaxTbl[cbDataBit]
		imul	bx			; lTmpDelta *= (int)lpzf->nMaxTbl[cbDataBit]
		add	ax,8192 		; lTmpDelta += 8192
		adc	dx,0			;
		;
d_000:		shl	ax,1			; lTmpDelta >>= 14
		rcl	dx,1			; get nDelta
		shl	ax,1			;
		rcl	dx,1			;
		mov	es:[di+6],dx		;
cEnd


cProc Voc8Bit,<PUBLIC, NEAR>,<es, ds, si, di>
ParmD lpzf
cBegin
		les	di,lpzf 		;
		mov	ax,es:[di+4]		;
		cmp	ax,8191 		;
		jg	v_001			;
		cmp	ax,-8192		;
		jl	v_002			;
		jmp	v_003			;
v_001:
		mov	ax,8191 		;
		jmp	v_003			;
v_002:
		mov	ax,-8192		;
v_003:
		sar	ax,6			;
		add	ax,128			;
		and	ax,0ffh 		;
cEnd



cProc Quantize8BitWave,<PUBLIC, NEAR>,<es, ds, si, di>
ParmB cbDataBit
ParmW nEdata
ParmD lpzf
ParmD lpzfadpcm
cBegin
		les	di,lpzf 		;
		;
		and	es:[di+2],0ff00h	;
		mov	ax,nEdata		; nEdata = ax
		sub	ax,128			;
		shl	ax,6			;
		add	ax,32			;
		sub	ax,es:[di+4]		; lpzf->nEstMax
		jnz	q_000			; if ( nEdata -= lpzf->nEstMax )
		jmp	q_003			;
q_000:		;
		xor	bh,bh			;
		mov	bl,byte ptr es:[di+1]	; cbCompBit
		shl	bl,1			; bl = cbTmpCompBit = cbCompBit * 2
		;
		cmp	ax,0			; check nEdata
		jge	q_001			;
		neg	ax			; nEdata = -nEdata
		mov	cbDataBit,bl		; cbDataBit = cbTmpCompBit
q_001:		;
		sub	ax,es:[di+6]		; while (((nEdata -= lpzf->nDelta)>0)
						;	 && --cbTmpCompBit )
		dec	bl			;
		cmp	ax,0			;
		jle	q_002			;
		cmp	bl,0			;
		jz	q_002			;
		inc	cbDataBit		;	  cbDataBit += 1 ;
		jmp	q_001			;
q_002:		;
		mov	cl,7			;
		sub	cl,es:[di+1]		; cbCompBit
		mov	al,cbDataBit		;
		shl	al,cl			;
		xor	ah,ah			;
		or	es:[di+2],ax		; nRdata - Compress data
q_003:		;
		cld				;Initialize lpzfadpcm struct
		mov	bfPack,FALSE		;bfPack = FALSE
		les	di,lpzfadpcm		;data
		mov	cx,6			;
		xor	ax,ax			;
		rep	stosw			;
		;
		les	di,lpzf 		; check if the compressed data
						; can be pack into one byte
		xor	ch,ch			;
		mov	cl,byte ptr es:[di+1]	; lpzf->cbCompBit
		inc	cl			; cbTmpCompBit
p_002:		;
		jcxz	p_end			;
		dec	cl			;
		;
		shl	word ptr es:[di+2],1	;
		;
		dec	byte ptr es:[di+0]	;
		jnz	p_002			;
		;
		mov	dx,es:[di+2]		;  dh = cbAdpcm

		les	bx,lpzfadpcm		;
		mov	ax,bx			; save base address
		add	bx,es:[bx+10]		; get next write pointer
		mov	byte ptr es:[bx],dh	; lpzfadpcm->szAdpcmData[lpzfadpcm->nDataByte] = cbAdpcm;
		mov	bx,ax			; restore base address
		inc	word ptr es:[bx+10]	; lpzfadpcm->nDataByte++

		les	di,lpzf 		;
		mov	byte ptr es:[di+0],8	; lpzf->cbRcnt = 8
		mov	bfPack,TRUE		; bfPack = TRUE
		jmp	p_002
p_end:
		mov	ah,bfPack		;
		mov	al,cbDataBit		;
cEnd

sEnd CodeSeg

end
